#include <QGLViewer/qglviewer.h>
#include <qgl.h>
#include "mesh.h"

class Viewer: public QGLViewer {
 public:
  Viewer();
  ~Viewer();

  void init();
  void draw();

  void keyPressEvent(QKeyEvent *e);
  QString helpString() const;

 private:
  Mesh* mesh_;
  bool meshOK_;

  qglviewer::ManipulatedFrame* lightFrame_;
  bool   toogleShadowmap_;
  GLuint shadowmap_;
  int    shadowmapSize_;
  inline void initShadowmap();
  inline void drawLight() const;

  inline const bool checkExtension(const char* extName) const;
  inline const bool loadMesh(const QString& filename);
  inline void drawMesh() const;
};
