#ifndef ______dynamique_boule_hpp___________________
#define ______dynamique_boule_hpp___________________

namespace dynamique {

/** Teste la collision entre une boule et un plan, et applique les lois d'impact si collision il y a. 
\param x1 position de la premire boule
\param v1 vitesse de la premire boule
\param r1 rayon de la premire boule
\param invm1 masse inverse de la premire boule
\param x2 un point du plan
\param v2 vitesse du plan (suppos en translation)
\param normale vecteur unitaire normal au plan
\param invm2 masse inverse du plan (0 si fixe)
\param rebond coefficient de rebond, entre 0 et 1. Si 0, choc mou, si 1, choc lastique
*/
void collisionBoulePlan( SbVec3f& x1, SbVec3f& v1, double r1, double invm1, SbVec3f& x2, SbVec3f& v2, SbVec3f& normale, double invm2, double rebond );

/** Teste la collision entre deux boules, et applique les lois d'impact si collision il y a. 
\param x1 position de la premire boule
\param v1 vitesse de la premire boule
\param r1 rayon de la premire boule
\param invm1 masse inverse de la premire boule
\param x2 position de la deuxime boule
\param v2 vitesse de la deuxime boule
\param r2 rayon de la deuxime boule
\param invm2 masse inverse de la deuxime boule
\param rebond coefficient de rebond, entre 0 et 1. Si 0, choc mou, si 1, choc lastique
*/
void collisionBouleBoule( SbVec3f& x1, SbVec3f& v1, double r1, double invm1, SbVec3f& x2, SbVec3f& v2, double r2, double invm2, double rebond );

}
#endif
