#ifndef _______dynamique_common_hpp_________________
#define _______dynamique_common_hpp_________________

#include <Inventor/nodes/SoTransform.h>
#include <vector>

#include <iostream>
using std::ostream;
using std::istream;
using std::cout;
using std::cerr;
using std::endl;


// types et mthodes communs dans l'implmentation


namespace dynamique {

typedef std::vector<SbVec3f> Vector;          ///< tableau de vecteurs en dimension 3


/// produit scalaire
inline double operator * ( const SbVec3f& a, const SbVec3f& b )
{
	return a[0]*b[0] + a[1]*b[1] + a[2]*b[2];
}


/// criture d'un SbVec3f par l'oprateur <<
inline ostream& operator << (ostream& out, const SbVec3f& v )
{
	out << v[0] <<" "<< v[1] <<" "<< v[2];
	return out;
}

/// saisie d'un SbVec3f par l'oprateur <<
inline istream& operator >> (istream& in, SbVec3f& v )
{
	in >> v[0] >> v[1] >> v[2];
	return in;
}

/// criture d'un vecteur par l'oprateur <<
template<class T>
inline ostream& operator << (ostream& out, const std::vector<T>& v )
{
	typedef typename std::vector<T>::const_iterator Iter;
	for( Iter i=v.begin(), iend=v.end(); i!=iend; ++i)
		out << *i <<", ";
	return out;
}



}

#endif
