#include <Inventor/nodes/SoTransform.h>
#include "collision.hpp"
#include "common.hpp"

#include <iostream>
using std::cout;
using std::endl;

namespace dynamique {

void collisionBouleBoule( SbVec3f& x1, SbVec3f& v1, double r1, double m1, SbVec3f& x2, SbVec3f& v2, double r2, double m2 ){}

void collisionBoulePlan( SbVec3f& x1, SbVec3f& v1, double r1, double invm1, SbVec3f& x2, SbVec3f& v2, SbVec3f& normale, double invm2, double rebond )
{
	// ne pas traiter les objets fixes
	if( invm1==0 && invm2==0 ) return;
	
	// calcul de la distance au plan
	SbVec3f ecart = x1 - x2;
	double penetration = (ecart * normale) - r1;
	if( penetration > 0 ) return;
	
	//cout<<" penetration = " << penetration << endl;
	
	// vitesse de penetration
	double vpen = (v1-v2)*normale;
	
	//cout<<" vitesse de penetration = " << vpen << endl;
	
	// rpartition de la correction (le plus lourd bouge moins)
	double corr1 = invm1 / (invm1+invm2);
	double corr2 = invm2 / (invm1+invm2);
	
	// prise en compte du rebond
	corr1 *= (1+rebond);
	corr2 *= (1+rebond);
	
	// mise  jour des positions et vitesses
	x1 -= corr1 * penetration * normale;
	v1 -= corr1 * vpen * normale;
	x2 += corr2 * penetration * normale;
	v2 += corr2 * vpen * normale;
}

}

