#include <iostream>
#include "ressort.hpp"

namespace dynamique {

Ressort::Ressort( int o1, int o2, double k, double l, double n )
	: obj1(o1)
	, obj2(o2)
	, k(k)
	, l0(l)
	, nu(n)
{}

void Ressort::ajouteForce( Vector& forces, const Vector& pos, const Vector& vit )
{
	SbVec3f u( pos[obj2]-pos[obj1] );
	double distance = sqrt( u*u );
	if( distance < 1.0e-6 ) return;

	u *= 1/distance;  // u est maintenant un vecteur unitaire
	SbVec3f f = k*(distance-l0)*u + k*nu*(vit[obj2]*u - vit[obj1]*u) * u;
	
	//std::cout<< "force entre "<< obj1 <<" et "<< obj2 <<": "<< f << std::endl;

	forces[obj1] += f;
	forces[obj2] -= f;
}

}// dynamique
