#ifndef ___________ressort_hpp____________________
#define ___________ressort_hpp____________________

#include "common.hpp"

namespace dynamique {

/** Modlise un ressort linaire avec amortissement. Le facteur d'amortissement applique une force nu*k*(vitesse relative)  */
class Ressort {

public:
	double k;  ///< raideur
	double l0;  ///< longueur au repos
	double nu;  ///< facteur d'amortissement
	
	int obj1;  ///< indice du premier objet
	int obj2;  ///< indice du deuxime objet
	
	/// Constructeur avec indices des objets concerns, raideur, longueur au repos et facteur d'amortissement
	Ressort( int o1, int o2, double k, double l, double n );
	
	/// Applique la force aux particules concernes en fonction des positions et des vitesses.
	void ajouteForce( Vector& forces, const Vector& pos, const Vector& vit );

};

}//dynamique
#endif
