#ifndef _______________ivfiles_h________________________
#define _______________ivfiles_h________________________

#include <stdio.h>
#include <Inventor/actions/SoWriteAction.h>
#include <Inventor/SoInput.h>
#include <iostream>

/// Utilitaires divers pour OpenInventor
namespace iv {

/// lit le fichier filename et renvoie la racine de l'arbre correspondant
SoSeparator *
readFile(const char *filename)
{
   // Open the input file
   SoInput mySceneInput;
   if (!mySceneInput.openFile(filename)) {
      fprintf(stderr, "Cannot open file %s\n", filename);
      return NULL;
   }

   // Read the whole file into the database
   SoSeparator *myGraph = SoDB::readAll(&mySceneInput);
   if (myGraph == NULL) {
      fprintf(stderr, "Problem reading file\n");
      return NULL;
   } 

   mySceneInput.closeFile();
   return myGraph;
}


/// ecrit l'arbre de racine root dans le fichier filename
void writeFile( SoGroup* root, const char* filename )
{
	SoOutput out;
	if( !out.openFile(filename) ){
		fprintf(stderr, "Cannot open file %s for writing\n", filename);
	}
	SoWriteAction myWriteAction(&out);
	myWriteAction.apply(root);
}

}

/// criture d'un SbVec3f par l'oprateur <<
inline std::ostream& operator << (std::ostream& out, const SbVec3f& v )
{
	out << v[0] <<" "<< v[1] <<" "<< v[2];
	return out;
}

/// saisie d'un SbVec3f par l'oprateur <<
inline std::istream& operator >> (std::istream& in, SbVec3f& v )
{
	in >> v[0] >> v[1] >> v[2];
	return in;
}

#endif
